Unit Parser;
Interface
  Type
    CharSet=Set of Char;
    SortType=(stLeft,stRight,stCenter);
  const
    Sym='|';
    Space : CharSet=[' '];

  Procedure DelAllSym(var S : String;Sym : CharSet);
  Function GoWord(const S : String;n : Integer;Sym : CharSet) : Integer;
  Function GetWord(const S : String;n : Integer;Sym : CharSet) : String;
  Procedure DelWord(var S : String;n : Integer;Sym : CharSet);
  Procedure InsWord(var S : String;St : String;n : Integer;Sym : CharSet;c : String);
  Function NumWords(const S : String;Sym : CharSet) : Integer;
  Procedure Extend(var S : String;c : Char;n : Integer;Sort : SortType);
  Function NumToStr(n : LongInt) : String;
  Function CaseUp(c : Char) : Char;
  Function GetLine(var S : String;const DisplayLabel : Array of Integer) : String;
  procedure DosWin(var S:String);
  procedure WinDos(var S:String);
  function  Change(S:String;const  St,Sn:String):String;
  Function UpString(const S : String) : String;

Implementation

Const
  DosRus:String='';
  WinRus:String='';
Var
  DosToWin:Array[Char] of Char;
  WinToDos:Array[Char] of Char;

Function GetWord(const S : String;n : Integer;Sym : CharSet) : String;
var
  i1,i2 : Integer;
  St : String;
Begin
  GetWord := '';
  i1 := GoWord(S,n,Sym);
  IF i1=0 Then Exit;
  i2 := GoWord(S,n+1,Sym);
  IF i2=0 Then
    St := Copy(S,i1,Length(S)-i1+1)
  Else
    St := Copy(S,i1,i2-i1);
  DelAllSym(St,Sym);
  GetWord := St;
End;

Procedure DelAllSym(var S : String;Sym : CharSet);
Begin
  While (S<>'') and (S[1] in Sym) do Delete(S,1,1);
  While (S<>'') and (S[Length(S)] in Sym) do Delete(S,Length(S),1);
End;

Function GoWord(const S : String;n : Integer;Sym : CharSet) : Integer;
var
  j,i : Integer;
Begin
  i := 1;
  j := 1;
  While (i<=Length(S)) and (S[i] in Sym) do
    Inc(i);
  While (j<n) and (i<=Length(S)) do
  begin
    IF S[i] in Sym Then
    begin
      Inc(j);
      While (i<=Length(S)) and (S[i] in Sym)  do
        Inc(i);
    end
    Else
      Inc(i);
  end;
  IF i>Length(S) Then i := 0;
  GoWord := i;
End;

Procedure DelWord(var S : String;n : Integer;Sym : CharSet);
var
  i1,i2 : Integer;
Begin
  i1 := GoWord(S,n,Sym);
  IF i1=0 Then Exit;
  i2 := GoWord(S,n+1,Sym);
  IF i2=0 Then
    Delete(S,i1,Length(S)-i1+1)
  Else
    Delete(S,i1,i2-i1);
End;

Procedure InsWord(var S : String;St : String;n : Integer;Sym : CharSet;c : String);
{
  S - 㤠
  St - 
  n - ᫮ ⠭ n  
  Sym - ⢮ ࠧ⥫
  c - ࠧ⥫
}
var
  i : Integer;
Begin

  i := GoWord(S,n,Sym);
  IF i=0 Then
  begin
    IF Length(S)>Length(c) Then
      For i := Length(c) downto 1 do
        IF c[i]<>S[Length(S)-Length(c)+i] Then
        begin
          S := S+c;
          Break;
        end;
    S := S+St;
    Exit;
  end;
  Insert(c,S,i);
  Insert(St,S,i);
End;

Function NumWords(const S : String;Sym : CharSet) : Integer;
var
  j : Integer;
Begin
  j := 1;
  While GoWord(S,j,Sym)<>0 do
    Inc(j);
  NumWords := j-1;
End;

Procedure Extend(var S : String;c : Char;n : Integer;Sort : SortType);
var
  i : Integer;
Begin
  IF Sort in [stLeft,stRight] Then
    While Length(S)<n do
      IF Sort=stLeft Then
        S := S+c
      Else
        S := c+S;
  IF Sort=stCenter Then
  begin
    For i := 1 to (n-Length(S)) div 2 do S := S+c;
    While Length(S)<n do S := c+S;
  end;
End;

Function NumToStr(n : LongInt) : String;
const
  Num:Array[0..4] of LongInt=(1,1000,1000000,1000000000,1);
  Decimal : Array[0..19] of String[20]=
    ('',' ',' ',' ',' ',' ',' ',' ',' ',
     ' ',' ',' ',' ',' ',
     ' ',' ',' ',' ',
     ' ',' ');
  Ten : Array[0..9] of String[20]=
    ('',' ',' ',' ',' ',' ',' ',' ',
     ' ',' ');
  Hundred : Array[0..9] of String[20]=
    ('',' ',' ',' ',' ',' ',' ',
     ' ',' ',' ');
  Words : Array[1..3,0..4] of String[20]=(
    ('',' ',' ',' ',' '),
    ('',' ',' ',' ',' '),
    ('',' ',' ',' ',' '));
function GetWord(i:LongInt;j : Integer) : String;
begin
  If (i mod 100) in [10..20] then
    GetWord:=Words[3,j]
  Else
    Case (i mod 10) of
      1    :GetWord := Words[1,j];
      2,3,4:GetWord := Words[2,j];
    Else
      GetWord := Words[3,j];
    End;
end;

function GetDec(i:LongInt;j:Integer):String;
begin
  GetDec:=Decimal[i];
  If (j=1) then
  begin
    If i=1 then
      GetDec:=' '
    else If i=2 then
      GetDec:=' ';
  end;
end;

function Int10(i:LongInt;j:Integer):String;
begin
  i:=i mod 100;
  If (i<=10) or (i>=20) then
    Int10:=Ten[i div 10]+GetDec(i mod 10,j)
  else
    Int10:=GetDec(i,j);
end;

function Int100(i:LongInt;j:Integer):String;
begin
  Int100:=Hundred[(i mod 1000) div 100]+Int10(i,j);
end;

var
  j,i:LongInt;
  S:String;
begin { NumToStr }
  S:='';
  For j:=3 downto 0 do
  begin
    i:=n div Num[j];
    S:=S+Int100(i,j);
    If (i<>0) or (j=0) then
      S:=S+GetWord(i,j);
    n:=n mod Num[j];
  end;
  NumToStr:=S;
end; { NumToStr }

Function CaseUp(c : Char) : Char;
const
  LowS : String ='abcdefghijklmnopqrstuvwxyz';
  HighS : String='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var
  i : Integer;
Begin
  Result := c;
  For i := 1 to Length(LowS) do
    IF c=LowS[i] Then
    begin
      Result := HighS[i];
      Break;
    end;
End;

Function GetLine(var S : String;const DisplayLabel : Array of Integer) : String;
var
  i,j,k,p : Integer;
  St,Sp,Sq,Sk : String;
Begin
  Sk := ''; {  S }
  Sq := '|'; {   }
  p := NumWords(S,[Sym]);
  For i := 1 to NumWords(S,[Sym]) do
  begin
    Sp := GetWord(S,i,[Sym]); {   }
    St := ''; {   }
    j := 1;
    k := NumWords(Sp,Space);
    While (Length(St)<=DisplayLabel[i-1]) and (j<=k) do
    begin
      St := St+' '+GetWord(Sp,j,Space);
      Inc(j);
    end;
    DelAllSym(St,Space);
    IF Length(St)>DisplayLabel[i-1] Then
      DelWord(St,j-1,Space);
    DelAllSym(St,Space);
    For j := 1 to NumWords(St,Space) do
      DelWord(Sp,1,Space);
    DelAllSym(Sp,Space);
    Extend(St,' ',DisplayLabel[i-1],stLeft);
    Sq := Sq+St+'|';
    IF Sp='' Then Sp := ' ';
    Sk := Sk+Sp+Sym;
  end;
  IF NumWords(Sq,[Sym]+Space)=0 Then Sq := '';
  GetLine := Sq;
  While NumWords(Sk,[Sym])<p do Sk := Sk+' |';
  S := Sk;
End;

procedure DosWin(var S:String);
var
  i:Integer;
begin
  For i:=1 to Length(S) do
    S[i]:=DosToWin[S[i]];
end;

procedure WinDos(var S:String);
var
  i:Integer;
begin
  For i:=1 to Length(S) do
    S[i]:=WinToDos[S[i]];
end;

procedure Init;
var
  i:Integer;
  c:Char;
begin
  For c:=#1 to #255 do
  begin
    DosToWin[c]:=c;
    WinToDos[c]:=c;
  end;
  For i:=1 to Length(DosRus) do
    DosToWin[DosRus[i]]:=WinRus[i];
  For i:=1 to Length(WinRus) do
    WinToDos[WinRus[i]]:=DosRus[i];
end;

function  Change(S:String;const St,Sn:String):String;
begin
  While Pos(St,S)<>0 do
    S:=Copy(S,1,Pos(St,S)-1)+Sn+
       Copy(S,Pos(St,S)+Length(St),Length(S)-Pos(St,S)-Length(St)+1);
  Result:=S;
end;

Function UpString(const S : String) : String;
var
  i : Integer;
Begin
  Result := '';
  For i := 1 to Length(S) do
    Result := Result + CaseUp(S[i]);
End;

BEGIN
  Init;
END.
