{*******************************************************}
{                                                       }
{         Delphi VCL eXtensions   (X)                   }
{                                                       }
{         Copyright (c) 1997 Alexander Buzaev           }
{                                                       }
{*******************************************************}

unit XConv;

interface

Uses SysUtils;

function AsInteger(S:String):LongInt;
function AsFloat(S:String):Extended;
function AsDate(S:String):TDateTime;
function AsTime(S:String):TDateTime;
function DateToString(D : TDateTime) : String;
function IsDigit(var s: String): Boolean;

implementation
const
  DigSet=['0'..'9'];

procedure Clear(var S:String);
begin
  While Pos(ThousandSeparator,S)<>0 do
    Delete(S,Pos(ThousandSeparator,S),1);
  While Pos(' ',S)<>0 do
    Delete(S,Pos(' ',S),1);
end;

function AsInteger(S:String):LongInt;
var
  S0:String;
begin
  Result:=0;
  Clear(S);
  S0:=S;
  If S='' then Exit;
  If S[1] in ['-','+'] then Delete(S,1,1);
  If Length(S)>9 then Exit;
  If S='' then Exit;
  If not (S[1] in DigSet) then Exit;
  While (S<>'') and (S[1] in DigSet) do
    Delete(S,1,1);
  If S<>'' then Exit;
  Result:=StrToInt(S0);
end;

function IsDigit(var s: String): Boolean;
var
  DS:Char;
  S0:String;
  L:LongInt;
Begin
  Result:=False;
  Clear(S);
  S0:=S;
  DS:=DecimalSeparator;
  If S='' then Exit;
  If S[1] in ['+','-'] then Delete(S,1,1);
  If (S='') or not (S[1] in DigSet) then Exit;
  While (S<>'') and (S[1] in DigSet) do
    Delete(S,1,1);
  If S<>'' then
  begin
    If S[1]=DS then
    begin
      Delete(S,1,1);
      If (S='') or not (S[1] in DigSet) then Exit;
      While (S<>'') and (S[1] in DigSet) do
        Delete(S,1,1);
    end;
    If S<>'' then
    begin
      If UpCase(S[1])<>'E' then Exit;
      Delete(S,1,1);
      L:=AsInteger(S);
      If (L=0) or (L<-300) or (L>300) then Exit;
    end;
  end;
  try
    StrToFloat(S0);
    Result:=True;
  except
  end;
  s:=s0;
End;

function AsFloat(S:String):Extended;
begin
  IF IsDigit(s) Then
    Result:=StrToFloat(S)
  Else
    Result:=0;
end;

function AsDate(S:String):TDateTime;
Begin
  Try
    Result:=StrToDate(S);
  Except
    Result:=0;
  End;
End;

function AsTime(S:String):TDateTime;
Begin
  Try
    Result:=StrToTime(S);
  Except
    Result:=0;
  End;
End;

function DateToString(D : TDateTime) : String;
const
  Months : Array[1..12] of String=
    ('','','','','','',
     '','','','','','');
var
  Year, Month, Day : Word;
Begin
  DecodeDate(D,Year,Month,Day);
  Result := IntToStr(Day)+' '+Months[Month]+' '+IntToStr(Year)+'.'
End;

end.
